## crash 7.2.3+real

=== debian/changelog ===
crash (7.2.3+real-1~16.04.1) xenial; urgency=medium

  * Backport to xenial. LP: #1746088
    - Build-Depends on debhelper 9.

 -- Thadeu Lima de Souza Cascardo <cascardo@canonical.com>  Tue, 26 Jun 2018 14:32:30 -0300

crash (7.2.3+real-1) unstable; urgency=medium

  * Revert wget addition and re-include embedded gdb (Closes: #901863)

 -- Troy Heber <troyh@debian.org>  Fri, 22 Jun 2018 15:39:16 -0600

crash (7.2.3-2) unstable; urgency=medium

  * Add wget as a builddep

 -- Troy Heber <troyh@debian.org>  Tue, 22 May 2018 09:16:03 -0600

crash (7.2.3-1) unstable; urgency=medium

  * Fix for a crash-7.2.2 regression that may cause the "mount" command to
    generate a segmentation violation.  The bug is dependent upon the compiler
    version used to build the crash utility, where a buffer overrun is not
    seen with more recent versions of gcc, which hide the bug due to a
    different stack layout of a function's local variables.

  * Fix for a second crash-7.2.2 buffer overrun regression that may cause the
    "rd -S" option to generate a segmentation violation if a displayed memory
    location contains a slab object address.

  * Fix for a third, highly unlikely, crash-7.2.2 buffer overrun regression,
    that could potentially occur during session initialization.

 -- Troy Heber <troyh@debian.org>  Mon, 21 May 2018 14:01:30 -0600

crash (7.2.2-1) UNRELEASED; urgency=medium

  * Fix to support Linux 4.16-rc1 and later ARM64 kernels, which fail during
    session initialization with the error message "crash: cannot determine
    page size".  The failure to determine the page size is due to the
    combination of the following kernel commits: - Linux 4.6 commit
    6ad1fe5d9077a1ab40bf74b61994d2e770b00b14 arm64: avoid R_AARCH64_ABS64
    relocations for Image header fields - Linux 4.10 commit
    4b65a5db362783ab4b04ca1c1d2ad70ed9b0ba2a arm64: Introduce
    uaccess_{disable,enable} functionality based on TTBR0_EL1 - Linux 4.16
    commit 1e1b8c04fa3451e2b7190930adae43c95f0fae31 arm64: entry: Move the
    trampoline to be before PAN

  * Fix the search for the booted kernel on a live system to prevent selecting
    the unusable "vmlinux.o" file found in private build directories.  Without
    the patch, the non-executable vmlinux.o file may be selected, and the
    resulting fatal error message indicates a somewhat misleading "crash:
    cannot resolve _stext".

  * Implemented a new "ps -A" option that restricts the task output to just
    the active tasks on each cpu.

  * As the first step in optimizing the is_page_ptr() function, save the
    maximum SPARSEMEM section number during initialization, and use it as the
    topmost delimeter in subsequent mem_section searches.  Also allow for
    per-architecture machdep->is_page_ptr() plugin functions.

  * Implemented the x86_64 machdep->is_page_ptr() plugin function.  If the
    kernel is configured with CONFIG_SPARSEMEM_VMEMMAP, the plugin function
    optimizes the mem_section search, reducing the computation effort and time
    consumed by commands that repeatedly call the is_page_ptr() function on
    large-memory systems.

  * Fixes for 32-bit X86 "bt" command on kernels that have been compiled with
    retpoline gcc support.  Without the patch, backtraces may fail with the
    error message "bt: cannot resolve stack trace", followed by the text
    symbols found on the stack and possible exception frames.

  * Fix the "help foreach" argument list to include the new "gleader" task
    qualifier option that was added in version 7.1.2.

  * VMware VMSS dumpfiles contain the state of each vCPU at the time when the
    VM was suspended.  This patch enables crash to read the relevant registers
    from each vCPU state for use as the starting hooks by the "bt" command.
    Also, support for "help -[D|n]" to display dumpfile contents, and "help
    -r" to display vCPU register sets has been implemented.  This is also the
    first step towards implementing automatic KASLR offset calculations for
    VMSS dumpfiles.

  * Commit 45b74b89530d611b3fa95a1041e158fbb865fa84 added support for
    calculating phys_base and the mapped kernel offset for KASLR-enabled
    kernels on SADUMP dumpfiles by using a technique developed by Takao Indoh.
    Originally, the patchset included support for kdumps, but this was dropped
    in v2, as it was deemed unnecessary due to the upstream implementation of
    the "vmcoreinfo device" in QEMU.  However, there are still several reasons
    for which the vmcoreinfo device may not be present at the time when a
    memory dump is taken from a VM, ranging from a host running older
    QEMU/libvirt versions, to misconfigured VMs or environments running
    Hypervisors that doesn't support this device.  This patchset generalizes
    the KASLR-related functions from sadump.c and moves them to
    kaslr_helper.c, and makes kdump analysis fall back to KASLR offset
    calculation if vmcoreinfo data is missing.

  * Fix for the "bt" command on 4.16 and later kernels size in which the
    "thread_union" data structure is not contained in the vmlinux file's
    debuginfo data.  Without the patch, the kernel stack size is not
    calculated correctly, and defaults to 8K.  As a result "bt" fails with the
    message "bt: invalid RSP: <address> bt->stackbase/stacktop:
    <address>/<address> cpu: <number>".

  * Fix for the x86_64 "bt" command for kernels that are configured with
    CONFIG_FRAME_POINTER.  Without the patch, the per-text-return-address
    framesize cache may contain invalid entries for functions that have an
    "and $0xfffffffffffffff0,%rsp" instruction in their prologue, which aligns
    the stack on a 16-byte boundary; therefore any cached framesize for a
    text-return-address in such a function may be incorrect depending upon the
    alignment of the stack address of a calling function.  If an invalid
    cached framesize is utilized by "bt", the backtrace may skip over several


=== debian/control ===
Source: crash
Section: utils
Priority: optional
Maintainer: Troy Heber <troyh@debian.org>
Uploaders:
Build-Depends: debhelper (>= 9), dpkg-dev (>= 1.16.1), quilt (>= 0.47), binutils, binutils-dev, bison, gawk, flex, zlib1g-dev, libncurses5-dev, liblzo2-dev, libsnappy-dev
Standards-Version: 4.1.3.0
XS-Testsuite: autopkgtest

Package: crash
Architecture: linux-any
Depends: ${shlibs:Depends}, ${misc:Depends}, binutils
Suggests: kexec-tools, makedumpfile
Description: kernel debugging utility, allowing gdb like syntax
 The core analysis suite is a self-contained tool that can be used to
 investigate either live systems, or multiple different core dump formats
 including kdump, LKCD, netdump and diskdump.
 .
 o  The tool is loosely based on the SVR4 crash command, but has been
    completely integrated with gdb in order to be able to display
    formatted kernel data structures, disassemble source code, etc.
 .
 o  The current set of available commands consist of common kernel core
    analysis tools such as a context-specific stack traces, source code
    disassembly, kernel variable displays, memory display, dumps of
    linked-lists, etc.  In addition, any gdb command may be entered,
    which in turn will be passed onto the gdb module for execution.
 .
 o  There are several commands that delve deeper into specific kernel
    subsystems, which also serve as templates for kernel developers
    to create new commands for analysis of a specific area of interest.
    Adding a new command is a simple affair, and a quick recompile
    adds it to the command menu.
 .
 o  The intent is to make the tool independent of Linux version dependencies,
    building in recognition of major kernel code changes so as to adapt to
    new kernel versions, while maintaining backwards compatibility.

## crash 7.2.5

=== Makefile ===
# Makefile for core analysis suite
#
# Copyright (C) 1999, 2000, 2001, 2002 Mission Critical Linux, Inc.
#       www.missioncriticallinux.com, info@missioncriticallinux.com
#
# Copyright (C) 2002-2016 David Anderson
# Copyright (C) 2002-2016 Red Hat, Inc. All rights reserved.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#

PROGRAM=crash

#
# Supported targets: X86 ALPHA PPC IA64 PPC64 SPARC64
# TARGET and GDB_CONF_FLAGS will be configured automatically by configure
#
TARGET=
GDB_CONF_FLAGS=

ARCH := $(shell uname -m | sed -e s/i.86/i386/ -e s/sun4u/sparc64/ -e s/arm.*/arm/ -e s/sa110/arm/)
ifeq (${ARCH}, ppc64)
CONF_FLAGS = -m64
endif

#
# GDB, GDB_FILES, GDB_OFILES and GDB_PATCH_FILES will be configured automatically by configure 
#
GDB=gdb-7.6
GDB_FILES=${GDB_7.6_FILES}
GDB_OFILES=
GDB_PATCH_FILES=gdb-7.6.patch gdb-7.6-ppc64le-support.patch gdb-7.6-proc_service.h.patch

#
# Default installation directory
#
INSTALLDIR=${DESTDIR}/usr/bin

# LDFLAGS will be configured automatically by configure
LDFLAGS=

GENERIC_HFILES=defs.h xen_hyper_defs.h xen_dom0.h
MCORE_HFILES=va_server.h vas_crash.h
REDHAT_HFILES=netdump.h diskdump.h makedumpfile.h xendump.h kvmdump.h qemu-load.h
LKCD_DUMP_HFILES=lkcd_vmdump_v1.h lkcd_vmdump_v2_v3.h lkcd_dump_v5.h \
        lkcd_dump_v7.h lkcd_dump_v8.h
LKCD_OBSOLETE_HFILES=lkcd_fix_mem.h
LKCD_TRACE_HFILES=lkcd_x86_trace.h
IBM_HFILES=ibm_common.h
SADUMP_HFILES=sadump.h
UNWIND_HFILES=unwind.h unwind_i.h rse.h unwind_x86.h unwind_x86_64.h
VMWARE_HFILES=vmware_vmss.h

CFILES=main.c tools.c global_data.c memory.c filesys.c help.c task.c \
	kernel.c test.c gdb_interface.c configure.c net.c dev.c bpf.c \
	alpha.c x86.c ppc.c ia64.c s390.c s390x.c s390dbf.c ppc64.c x86_64.c \
	arm.c arm64.c mips.c sparc64.c \
	extensions.c remote.c va_server.c va_server_v1.c symbols.c cmdline.c \
	lkcd_common.c lkcd_v1.c lkcd_v2_v3.c lkcd_v5.c lkcd_v7.c lkcd_v8.c\
	lkcd_fix_mem.c s390_dump.c lkcd_x86_trace.c \
	netdump.c diskdump.c makedumpfile.c xendump.c unwind.c unwind_decoder.c \
	unwind_x86_32_64.c unwind_arm.c \
	xen_hyper.c xen_hyper_command.c xen_hyper_global_data.c \
	xen_hyper_dump_tables.c kvmdump.c qemu.c qemu-load.c sadump.c ipcs.c \
	ramdump.c vmware_vmss.c \
	xen_dom0.c kaslr_helper.c

SOURCE_FILES=${CFILES} ${GENERIC_HFILES} ${MCORE_HFILES} \
	${REDHAT_CFILES} ${REDHAT_HFILES} ${UNWIND_HFILES} \
	${LKCD_DUMP_HFILES} ${LKCD_TRACE_HFILES} ${LKCD_OBSOLETE_HFILES}\
	${IBM_HFILES} ${SADUMP_HFILES} ${VMWARE_HFILES}

OBJECT_FILES=main.o tools.o global_data.o memory.o filesys.o help.o task.o \
	build_data.o kernel.o test.o gdb_interface.o net.o dev.o bpf.o \
	alpha.o x86.o ppc.o ia64.o s390.o s390x.o s390dbf.o ppc64.o x86_64.o \
	arm.o arm64.o mips.o sparc64.o \
	extensions.o remote.o va_server.o va_server_v1.o symbols.o cmdline.o \
	lkcd_common.o lkcd_v1.o lkcd_v2_v3.o lkcd_v5.o lkcd_v7.o lkcd_v8.o \
	lkcd_fix_mem.o s390_dump.o netdump.o diskdump.o makedumpfile.o xendump.o \
	lkcd_x86_trace.o unwind_v1.o unwind_v2.o unwind_v3.o \
	unwind_x86_32_64.o unwind_arm.o \
	xen_hyper.o xen_hyper_command.o xen_hyper_global_data.o \
	xen_hyper_dump_tables.o kvmdump.o qemu.o qemu-load.o sadump.o ipcs.o \
	ramdump.o vmware_vmss.o \
	xen_dom0.o kaslr_helper.o

MEMORY_DRIVER_FILES=memory_driver/Makefile memory_driver/crash.c memory_driver/README

# These are the current set of crash extensions sources.  They are not built
# by default unless the third command line of the "all:" stanza is uncommented.
# Alternatively, they can be built by entering "make extensions" from this
# directory.

EXTENSIONS=extensions
EXTENSION_SOURCE_FILES=${EXTENSIONS}/Makefile ${EXTENSIONS}/echo.c ${EXTENSIONS}/dminfo.c \
	${EXTENSIONS}/snap.c ${EXTENSIONS}/snap.mk ${EXTENSIONS}/trace.c \
	${EXTENSIONS}/eppic.c ${EXTENSIONS}/eppic.mk

DAEMON_OBJECT_FILES=remote_daemon.o va_server.o va_server_v1.o \
	lkcd_common.o lkcd_v1.o lkcd_v2_v3.o lkcd_v5.o lkcd_v7.o lkcd_v8.o \
	s390_dump.o netdump_daemon.o

GDB_5.0_FILES=${GDB}/gdb/Makefile.in \
	  ${GDB}/gdb/main.c ${GDB}/gdb/symtab.c ${GDB}/gdb/target.c \
	  ${GDB}/gdb/blockframe.c ${GDB}/gdb/alpha-tdep.c \
	  ${GDB}/gdb/symfile.c ${GDB}/gdb/elfread.c \
	  ${GDB}/gdb/ui-file.c ${GDB}/gdb/utils.c ${GDB}/gdb/gnu-regex.c \
	  ${GDB}/gdb/ppc-linux-nat.c
GDB_5.0_OFILES=${GDB}/gdb/main.o ${GDB}/gdb/symtab.o ${GDB}/gdb/target.o \
          ${GDB}/gdb/blockframe.o ${GDB}/gdb/alpha-tdep.o \
          ${GDB}/gdb/symfile.o ${GDB}/gdb/elfread.o \
          ${GDB}/gdb/ui-file.o ${GDB}/gdb/utils.o ${GDB}/gdb/gnu-regex.o \
          ${GDB}/gdb/ppc-linux-nat.o

GDB_5.1_FILES=${GDB}/gdb/Makefile.in \
	  ${GDB}/gdb/main.c ${GDB}/gdb/symtab.c ${GDB}/gdb/target.c \
	  ${GDB}/gdb/blockframe.c ${GDB}/gdb/alpha-tdep.c \
	  ${GDB}/gdb/symfile.c ${GDB}/gdb/elfread.c \
	  ${GDB}/gdb/ui-file.c ${GDB}/gdb/utils.c  ${GDB}/gdb/gnu-regex.c
GDB_5.1_OFILES=${GDB}/gdb/main.o ${GDB}/gdb/symtab.o ${GDB}/gdb/target.o \
          ${GDB}/gdb/blockframe.o ${GDB}/gdb/alpha-tdep.o \
          ${GDB}/gdb/symfile.o ${GDB}/gdb/elfread.o \
          ${GDB}/gdb/ui-file.o ${GDB}/gdb/utils.o ${GDB}/gdb/gnu-regex.o

GDB_5.2.1_FILES=${GDB}/gdb/Makefile.in \
          ${GDB}/gdb/main.c ${GDB}/gdb/symtab.c ${GDB}/gdb/target.c \
          ${GDB}/gdb/blockframe.c ${GDB}/gdb/alpha-tdep.c \
          ${GDB}/gdb/symfile.c ${GDB}/gdb/elfread.c \
          ${GDB}/gdb/ui-file.c ${GDB}/gdb/utils.c
GDB_5.2.1_OFILES=${GDB}/gdb/main.o ${GDB}/gdb/symtab.o ${GDB}/gdb/target.o \
          ${GDB}/gdb/blockframe.o ${GDB}/gdb/alpha-tdep.o \
          ${GDB}/gdb/symfile.o ${GDB}/gdb/elfread.o \
          ${GDB}/gdb/ui-file.o ${GDB}/gdb/utils.o 

GDB_5.3post-0.20021129.36rh_FILES=${GDB}/gdb/Makefile.in \
          ${GDB}/gdb/main.c ${GDB}/gdb/symtab.c ${GDB}/gdb/target.c \
          ${GDB}/gdb/frame.c ${GDB}/gdb/alpha-tdep.c \
          ${GDB}/gdb/symfile.c ${GDB}/gdb/elfread.c \
          ${GDB}/gdb/ui-file.c ${GDB}/gdb/utils.c ${GDB}/gdb/dwarf2read.c
GDB_5.3post-0.20021129.36rh_OFILES=${GDB}/gdb/main.o ${GDB}/gdb/symtab.o \
          ${GDB}/gdb/target.o ${GDB}/gdb/frame.o ${GDB}/gdb/alpha-tdep.o \
          ${GDB}/gdb/symfile.o ${GDB}/gdb/elfread.o ${GDB}/gdb/ui-file.o \
          ${GDB}/gdb/utils.o ${GDB}/gdb/dwarf2read.o

GDB_6.0_FILES=${GDB}/gdb/Makefile.in ${GDB}/Makefile.in \
          ${GDB}/gdb/main.c ${GDB}/gdb/symtab.c ${GDB}/gdb/target.c \
          ${GDB}/gdb/symfile.c ${GDB}/gdb/elfread.c \
          ${GDB}/gdb/ui-file.c ${GDB}/gdb/utils.c \
	  ${GDB}/gdb/ppc-linux-tdep.c ${GDB}/sim/ppc/ppc-instructions \
	  ${GDB}/bfd/simple.c ${GDB}/include/obstack.h
GDB_6.0_OFILES=${GDB}/gdb/main.o ${GDB}/gdb/symtab.o \
          ${GDB}/gdb/target.o ${GDB}/gdb/symfile.o ${GDB}/gdb/elfread.o \
          ${GDB}/gdb/ui-file.o ${GDB}/gdb/utils.o \
	  ${GDB}/gdb/ppc-linux-tdep.o ${GDB}/bfd/simple.o

GDB_6.1_FILES=${GDB}/gdb/Makefile.in ${GDB}/Makefile.in \
          ${GDB}/gdb/main.c ${GDB}/gdb/symtab.c ${GDB}/gdb/target.c \
          ${GDB}/gdb/symfile.c ${GDB}/gdb/elfread.c \
          ${GDB}/gdb/ui-file.c ${GDB}/gdb/utils.c ${GDB}/gdb/dwarf2read.c \
          ${GDB}/include/obstack.h ${GDB}/gdb/ppc-linux-tdep.c
GDB_6.1_OFILES=${GDB}/gdb/main.o ${GDB}/gdb/symtab.o \
          ${GDB}/gdb/target.o ${GDB}/gdb/symfile.o ${GDB}/gdb/elfread.o \
          ${GDB}/gdb/ui-file.o ${GDB}/gdb/utils.o ${GDB}/gdb/dwarf2read.o \
          ${GDB}/gdb/ppc-linux-tdep.o

GDB_7.0_FILES=
GDB_7.0_OFILES=${GDB}/gdb/symtab.o

GDB_7.3.1_FILES=
GDB_7.3.1_OFILES=${GDB}/gdb/symtab.o

GDB_7.6_FILES=
GDB_7.6_OFILES=${GDB}/gdb/symtab.o

# 
# GDB_FLAGS is passed up from the gdb Makefile.
#
GDB_FLAGS=

#
# WARNING_OPTIONS and WARNING_ERROR are both applied on a per-file basis. 
# WARNING_ERROR is NOT used on files including "dirty" gdb headers so that 
# successful compilations can be achieved with acceptable warnings; its 
# usefulness is also dependent upon the processor's compiler -- your mileage
# may vary.
#
#WARNING_OPTIONS=-Wall -O2 -Wstrict-prototypes -Wmissing-prototypes -fstack-protector -Wformat-security
#WARNING_ERROR=-Werror

# TARGET_CFLAGS will be configured automatically by configure
TARGET_CFLAGS=

CRASH_CFLAGS=-g -D${TARGET} ${TARGET_CFLAGS} ${GDB_FLAGS} ${CFLAGS}

GPL_FILES=COPYING3
TAR_FILES=${SOURCE_FILES} Makefile ${GPL_FILES} README .rh_rpm_package crash.8 \
	${EXTENSION_SOURCE_FILES} ${MEMORY_DRIVER_FILES}
CSCOPE_FILES=${SOURCE_FILES}

READLINE_DIRECTORY=./${GDB}/readline
BFD_DIRECTORY=./${GDB}/bfd
GDB_INCLUDE_DIRECTORY=./${GDB}/include

REDHATFLAGS=-DREDHAT

# target could be set on command line when invoking make. Like: make target=ARM
# otherwise target will be the same as the host
ifneq ($(target),)
CONF_TARGET_FLAG="-t$(target)"
endif

# To build the extensions library by default, uncomment the third command
# line below.  Otherwise they can be built by entering "make extensions".

all: make_configure
	@./configure ${CONF_TARGET_FLAG} -p "RPMPKG=${RPMPKG}" -b
	@make --no-print-directory gdb_merge
#	@make --no-print-directory extensions

gdb_merge: force
	@if [ ! -f ${GDB}/README ]; then \
	  make --no-print-directory gdb_unzip; fi
	@echo "${LDFLAGS} -lz -ldl -rdynamic" > ${GDB}/gdb/mergelibs
	@echo "../../${PROGRAM} ../../${PROGRAM}lib.a" > ${GDB}/gdb/mergeobj
	@rm -f ${PROGRAM}
	@if [ ! -f ${GDB}/config.status ]; then \
	  (cd ${GDB}; ./configure ${GDB_CONF_FLAGS} --with-separate-debug-dir=/usr/lib/debug \
	    --with-bugurl="" --with-expat=no --with-python=no --disable-sim; \
	  make --no-print-directory CRASH_TARGET=${TARGET}; echo ${TARGET} > crash.target) \
	else make --no-print-directory rebuild; fi
	@if [ ! -f ${PROGRAM} ]; then \
	  echo; echo "${PROGRAM} build failed"; \
	  echo; exit 1; fi

rebuild:
	@if [ ! -f ${GDB}/${GDB}.patch ]; then \
	  touch ${GDB}/${GDB}.patch; fi
	@if [ -f ${GDB}.patch ] && [ -s ${GDB}.patch ] && \
	  [ "`sum ${GDB}.patch`" != "`sum ${GDB}/${GDB}.patch`" ]; then \
	  (patch -N -p0 -r- --fuzz=0 < ${GDB}.patch; cp ${GDB}.patch ${GDB}; cd ${GDB}; \
	  make --no-print-directory CRASH_TARGET=${TARGET}) \
	else (cd ${GDB}/gdb; make --no-print-directory CRASH_TARGET=${TARGET}); fi

gdb_unzip:
	@rm -f gdb.files
	@for FILE in ${GDB_FILES} dummy; do\
	  echo $$FILE >> gdb.files; done
	@if [ ! -f ${GDB}.tar.gz ] && [ ! -f /usr/bin/wget ]; then \
	  echo /usr/bin/wget is required to download ${GDB}.tar.gz; echo; exit 1; fi
	@if [ ! -f ${GDB}.tar.gz ] && [ -f /usr/bin/wget ]; then \
	  wget http://ftp.gnu.org/gnu/gdb/${GDB}.tar.gz; fi
	@tar --exclude-from gdb.files -xvzmf ${GDB}.tar.gz
	@make --no-print-directory gdb_patch

gdb_patch:
	if [ -f ${GDB}.patch ] && [ -s ${GDB}.patch ]; then \
		patch -p0 < ${GDB}.patch; cp ${GDB}.patch ${GDB}; fi
	if [ "${ARCH}" = "ppc64le" ] && [ -f ${GDB}-ppc64le-support.patch ]; then \
		patch -d ${GDB} -p1 -F0 < ${GDB}-ppc64le-support.patch ; \
	fi
	if [ "${ARCH}" = "x86_64" ] && [ "${TARGET}" = "PPC64" ] && [ -f ${GDB}-ppc64le-support.patch ]; then \
		patch -d ${GDB} -p1 -F0 < ${GDB}-ppc64le-support.patch ; \
	fi
	if [ -f /usr/include/proc_service.h ]; then \
		grep 'extern ps_err_e ps_get_thread_area (struct' /usr/include/proc_service.h; \
		if [ $$? -eq 0 ]; then \
			patch -p0 < ${GDB}-proc_service.h.patch; \
		fi; \
	fi

library: make_build_data ${OBJECT_FILES}
	ar -rs ${PROGRAM}lib.a ${OBJECT_FILES}

gdb: force
	rm -f ${GDB_OFILES}
	@make --no-print-directory all

force:
	

make_configure: force
	@rm -f configure
	@${CC} ${CONF_FLAGS} -o configure configure.c ${WARNING_ERROR} ${WARNING_OPTIONS}

clean: make_configure
	@./configure ${CONF_TARGET_FLAG} -q -b
	@make --no-print-directory do_clean

do_clean:

=== debian/changelog ===
crash (7.2.5-1) unstable; urgency=medium

  * New upstream (Closes: #919291)

  * Resurrection of the "dev -p" option for displaying PCI device data on
    Linux 2.6.26 and later kernels.  The option was deprecated as of Linux
    2.6.26, and without the patch, the option would indicate "dev: -p option
    not supported or applicable on this architecture or kernel" when running
    against the newer kernel versions.  PCI Bus information will also be
    displayed with this patch.

  * With Linux 4.19-rc1 commit 7d4340bb92a9df78e6e28152f3dd89d9bd82146b,
    titled "powerpc/mm: Increase MAX_PHYSMEM_BITS to 128TB with
    SPARSEMEM_VMEMMAP config", the PPC64 MAX_PHYSMEM_BITS value has been
    bumped up to 47.  The appropriate update has been made in this patch.

  * Fix to allow piping command output to a shell script beginning with a
    shebang (#!) character sequence if the script pathname is specified with a
    preceding "./" or "/".  Without the patch, the piped command fails with
    the message "crash: pipe operation failed".

  * Fix for the PPC64 "bt" command to recognize when a thread is running in
    OPAL firmware.  Without the patch, the "bt" command indicates
    <task-address>: Invalid Stack Pointer <OPAL-firmware-address>"

  * As an addendum to the "dev -p" patch above, add the new structure member
    offsets for display by the "help -o" option.

  * Enhancement to the "kmem -n" option to dump memory block information if
    the kernel supports it.  In addition, the memory section data block has a
    new "STATE" column added to it.

  * Addendum to the previous "kmem -n" patch to fix a FTBFS issue.   Without
    the patch, certain architectures fail to compile with the error
    "memory.c:17315:16: error: ‘PAGE_SHIFT’ undeclared (first use in this
    function)"

  * Fix the calculation of the vmalloc memory region size to account for Linux
    4.17 commit a7412546d8cb5ad578805060b4006f2a021b5868, titled "x86/mm:
    Adjust vmalloc base and size at boot-time", which increases the region's
    size from 32TB to 1280TB when 5-level pagetables are enabled.  Also
    presume that virtual addresses above the end of the vmalloc space up to
    the beginning of vmemmap space are translatable via 5-level page tables.
    Without the patch, mapped virtual addresses may fail translation in
    whatever command accesses them, with errors indicating "seek error: kernel
    virtual address: <mapped-address>  type: <type-string>"

  * Address several Coverity Scan "RESOURCE_LEAK" issues in the following
    top-level source files: cmdline.c, kvmdump.c, lkcd_v8.c, xendump.c,
    symbols.c, unwind_x86_32_64.c, va_server.c and va_server_v1.c.

  * Modify the x86_64 "bt" behavior when a legitimate exception RIP value
    cannot be referenced symbolically, such as when the exception occurs while
    running in seccomp BPF filter code.  Without the patch, the exception
    frame register dump is preceded by "[exception RIP: unknown or invalid
    address]", and then followed by "bt: WARNING: possibly bogus exception
    frame".  With the patch applied, the translation of the exception RIP will
    show "[exception RIP: no symbolic reference]", and there will be no
    warning message.

  * Account for the /proc/kcore VMCOREINFO PT_NOTE in Linux 4.19 and later
    kernels having commit 23c85094fe1895caefdd19ef624ee687ec5f4507, titled
    "proc/kcore: add vmcoreinfo note to /proc/kcore".  The PT_NOTE information
    is stored during session initialization for later display by "help
    -[n|D]"; a subsequent commit will make it available for use by the crash
    utility's internal pc->read_vmcoreinfo() function.

  * Second phase of support for the VMCOREINFO PT_NOTE added to the ELF header
    of /proc/kcore in Linux 4.19 and later kernels.  This patch introduces
    support for live session /proc/kcore VMCOREINFO access by the crash
    utility's internal pc->read_vmcoreinfo() function.  New usage include the
    initialization of the x86_64 phys_base value, and the arm64 phys_offset,
    page size, and VA bits count.

  * Fix for Linux 4.20-rc1 and later kernels that contain kernel commit
    5c83511bdb9832c86be20fb86b783356e2f58062, titled "x86/paravirt: Use a
    single ops structure".  Without the patch, the kernel may be misidentified
    as an ARCH_XEN kernel, with the most noticeable result being the inability
    to read vmemmap'd page structures.

  * Implemented the functionality for a new MEMBER_TYPE_NAME() macro, which
    will return a pointer to the type name string of a structure member.  It
    is being put in place for the support of Linux 4.20 radix tree to xarray
    replacements, where structure member types may be changed from
    radix_tree_root structures to xarray structures.

  * First phase of support for the XArray facility.  The added support is
    similar to that of radix trees, but introduces completely separate
    functions, structures and #defines.  None of the applicable radix tree
    users in the crash utility have been switched over, so this phase does not
    introduce any functional changes.

  * Second phase of support for the XArray facility, which handles the
    switch-over of PID handling from a radix tree to an XArray in Linux 4.20
    and later kernels.  Without the patch, the crash session fails during
    session initialization with the message "crash: radix trees do not exist
    or have changed their format".

  * Third phase of support for the XArray facility, which consolidates the
    radix_tree_pair and xarray_pair structures into a unified list_pair
    structure that is used by both facilities, and fixes the "bpf" command.
    Without the patch, the command fails on Linux 4.20 or later kernels with
    the error message "bpf: radix trees do not exist or have changed their
    format".

  * Added support for usage of the XArray facility by the "files -p" option.


## crash 7.2.6

=== debian/changelog ===
crash (7.2.6-1build1) eoan; urgency=medium

  * No-change upload with strops.h and sys/strops.h removed in glibc.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 05 Sep 2019 10:47:07 +0000

crash (7.2.6-1) unstable; urgency=medium

  * Two fixes for the Xen hypervisor; the first fixes a bug seen with Xen
    4.11.0 during initialization, which fails with the error message "crash:
    invalid kernel virtual address: <address> type: fill_pcpu_struct",
    followed by "WARNING: cannot fill pcpu_struct" and "crash: cannot read
    cpu_info".  The second fix prevents a segmentation violation associated
    with a crash-7.1.1 commit that addressed the Xen 4.5.0 hypervisor symbol
    name change from "dom0" to "hardware_domain".

  * Fix for Linux 4.20 and later x86_64 kernels which are NOT configured with
    CONFIG_RANDOMIZE_BASE.  Linux 4.20 introduced kernel commit
    d52888aa2753e3063a9d3a0c9f72f94aa9809c15, titled "x86/mm: Move LDT remap
    out of KASLR region on 5-level paging", which modified the 4-level and
    5-level paging PAGE_OFFSET values.  Without this patch, the crash session
    fails during initialization with the error message "crash: read error:
    kernel virtual address: <address>  type: tss_struct ist array".  For
    kernels prior to Linux 4.20.0 which have backports of the kernel commit,
    the kernel's PAGE_OFFSET value must be manually specified via the command
    line option "--machdep page_offset=ffff888000000000" for kernels with
    4-level page tables, or "--machdep page_offset=ff11000000000000" for
    kernels with 5-level paging.  (or alternatively the shorter version "-m
    page_offset=<address>" may be used).  The command line option requirement

  * Fix for the "p" command if the expression contains more than one opening
    parenthesis character and a minus/dash sign.  Without the patch, the
    minus/dash sign will get dropped from the command prior to it being passed
    on to gdb for evaluation, and the command will fail with the message "p:
    gdb request failed: <expression>", where the <expression> string will not

  * Fix for the internal parse_line() utility function to account for embedded
    sets of parentheses, which may be used for expressions that are passed to
    gdb by the "p" command.  Without the patch, expressions containing
    embedded sets of parentheses are broken up into multiple argument tokens
    instead of just one.  The previous commit has been reverted by this one.

  * First phase of support for ARM64 kernels that are configured with
    CONFIG_ARM64_USER_VA_BITS_52, which causes the PTRS_PER_PGD count to
    increase from 64 to 1024.  Without the patch, "WARNING: cannot access
    vmalloc'd module memory" will be displayed during session initialization,
    and the translation of any mapped kernel virtual address that requires a
    page table walk will fail, leading to a myriad of other errors.

  * Support for configurable CONFIG_ARM64_PA_BITS values introduced in kernel
    commit 982aa7c5f0861bf56b2412ca341a13f44c238ba4, titled "arm64: add
    kconfig symbol to configure physical address size".  Without the patch, it
    is impossible to determine the value of CONFIG_ARM64_PA_BITS is, and will
    require a new MAX_PHYSMEM_BITS vmcoreinfo entry to be exported.  This

  * For live system analysis where there is no vmcoreinfo ELF note attached to
    /proc/kcore, or for dumpfile analysis where there is no vmcoreinfo ELF
    note attached to the dumpfile, this patch sets the internal
    pc->read_vmcoreinfo() function to a new plugin function that reads the
    data directly from the live kernel or dumpfile.  Because the function is
    set much later during initialization than if the ELF note is attached to
    /proc/kcore or the dumpfile, it may not be available during very early

  * Fix for Linux 4.14.84 and later 4.14-based x86_64 kernels which are NOT
    configured with CONFIG_RANDOMIZE_BASE and have backported kernel commit
    d52888aa2753e3063a9d3a0c9f72f94aa9809c15, titled "x86/mm: Move LDT remap
    out of KASLR region on 5-level paging", which modified the 4-level and
    5-level paging PAGE_OFFSET values.  Without this patch, the crash session
    fails during initialization with the error message "crash: read error:
    kernel virtual address: <address>  type: tss_struct ist array".

  * Fix for determining the x86_64 "phys_base" value in dumpfiles created by
    the KVM "virsh dump" facility if the kernel is KASLR-enabled and does not
    have the phys_base value stored in vmcoreinfo data.  Without the patch,
    the message "WARNING: cannot determine physical base address: defaulting
    to 0" is displayed, and the crash session fails to initialize.

  * 32-bit ARM kernels built with the Thumb-2 instruction set utilize the R7
    register instead of FP for unwinding stacks using the DWARF unwinder.  On
    those kernels, without the patch, the "bt" command only shows the task

  * Fix for the "kmem -z" option on Linux 5.0 and later kernels that contain
    commit a921444382b49cc7fdeca3fba3e278bc09484a27, titled "mm: move zone
    watermark accesses behind an accessor".  Without the patch, the command
    fails with the error message "kmem: invalid (optional) structure member
    offsets: zone_pages_min or zone_struct_pages_min".

  * Fix for the "kmem -i" option on Linux 5.0 and later kernels that contain
    commit ca79b0c211af63fa3276f0e3fd7dd9ada2439839 titled "mm: convert
    totalram_pages and totalhigh_pages variables to atomic".  Without the
    patch, the command prints some incorrect values, and besides does not
    print high/low memory information on kernels which are configured with

  * Fix for the display of kernel module symbol types by the "sym" command in
    Linux 5.0 and later kernels if the module debuginfo data has not been
    loaded into the crash session.  The st_info member of the Elf32_Sym or
    Elf64_Sym structures has changed so as to not contain ASCII symbol type


=== debian/control ===
--- 
+++ 
@@ -3,8 +3,8 @@
 Priority: optional
 Maintainer: Troy Heber <troyh@debian.org>
 Uploaders:
-Build-Depends: debhelper (>= 9), dpkg-dev (>= 1.16.1), quilt (>= 0.47), binutils, binutils-dev, bison, gawk, flex, zlib1g-dev, libncurses5-dev, liblzo2-dev, libsnappy-dev
-Standards-Version: 4.1.3.0
+Build-Depends: debhelper (>= 10), dpkg-dev (>= 1.16.1), quilt (>= 0.47), binutils, binutils-dev, bison, gawk, flex, zlib1g-dev, libncurses5-dev, liblzo2-dev, libsnappy-dev
+Standards-Version: 4.3.0.0
 XS-Testsuite: autopkgtest
 
 Package: crash

## crash 7.2.8

=== Makefile ===
--- 
+++ 
@@ -49,7 +49,7 @@
 
 GENERIC_HFILES=defs.h xen_hyper_defs.h xen_dom0.h
 MCORE_HFILES=va_server.h vas_crash.h
-REDHAT_HFILES=netdump.h diskdump.h makedumpfile.h xendump.h kvmdump.h qemu-load.h
+REDHAT_HFILES=netdump.h diskdump.h makedumpfile.h xendump.h kvmdump.h qemu-load.h vmcore.h
 LKCD_DUMP_HFILES=lkcd_vmdump_v1.h lkcd_vmdump_v2_v3.h lkcd_dump_v5.h \
         lkcd_dump_v7.h lkcd_dump_v8.h
 LKCD_OBSOLETE_HFILES=lkcd_fix_mem.h
@@ -245,7 +245,7 @@
 	  touch ${GDB}/${GDB}.patch; fi
 	@if [ -f ${GDB}.patch ] && [ -s ${GDB}.patch ] && \
 	  [ "`sum ${GDB}.patch`" != "`sum ${GDB}/${GDB}.patch`" ]; then \
-	  (patch -N -p0 -r- --fuzz=0 < ${GDB}.patch; cp ${GDB}.patch ${GDB}; cd ${GDB}; \
+	  (sh -x ${GDB}.patch ${TARGET}; patch -N -p0 -r- --fuzz=0 < ${GDB}.patch; cp ${GDB}.patch ${GDB}; cd ${GDB}; \
 	  make --no-print-directory CRASH_TARGET=${TARGET}) \
 	else (cd ${GDB}/gdb; make --no-print-directory CRASH_TARGET=${TARGET}); fi
 
@@ -294,4 +294,3 @@
 	@./configure ${CONF_TARGET_FLAG} -q -b
 	@make --no-print-directory do_clean
 
-do_clean:

=== debian/changelog ===
crash (7.2.8-1ubuntu1) focal; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - Update the maintainer field for Ubuntu.
    - If the "live" autopkgtest fails with a recommendation to try
      /proc/kcore instead of the default, attempt that before failing
      the test. LP: #1858958.
  * Fix test, as if will return 0 when no cases were true.

 -- Thadeu Lima de Souza Cascardo <cascardo@canonical.com>  Wed, 12 Feb 2020 22:12:51 +0000

crash (7.2.8-1) unstable; urgency=medium

  * New upstream (Closes: #950544)

  * Fix for Linux 5.4-rc1 and later kernels that contain commit
    688fcbfc06e4fdfbb7e1d5a942a1460fe6379d2d, titled "mm/vmalloc: modify
    struct vmap_area to reduce its size".  Without the patch "kmem -v" will
    display nothing; other architectures that utilize the vmap_area_list to
    determine the base of mapped/vmalloc address space will fail.

  * Fix for Linux 5.4-rc1 and later kernels that contain commit/merge
    e0703556644a531e50b5dc61b9f6ea83af5f6604, titled "Merge tag 'modules-
    for-v5.4' of git://git.kernel.org/pub/scm/linux/kernel/git/jeyu/linux
    which introduces symbol namespaces.  Without the patch, and depending upon
    the architecture:
    (1) the kernel module symbol list will contain garbage entries
    (2) the session fails during session initialization with a dump of
       the internal buffer allocation stats followed by the message
       "crash: cannot allocate any more memory!"
    (3) the session fails during session initialization with a
       segmentation violation.

  * Fix for the "timer -r" option on Linux 5.4-rc1 and later kernels that
    contain commit 511885d7061eda3eb1faf3f57dcc936ff75863f1, titled
    "lib/timerqueue: Rely on rbtree semantics for next timer".  Without the
    patch, the option fails with the following error "timer: invalid structure
    member offset: timerqueue_head_next".

  * Fix for a "[-Wstringop-truncation]" compiler warning emitted when
    symbols.c is built in a Fedora Rawhide environment with gcc-9.0.1 or
    later.

  * Fix for the "kmem -n" option on Linux-5.4-rc1 and later kernels that
    contain commit b6c88d3b9d38f9448e0fcf44847a075ea81d5ca2, titled
    "drivers/base/memory.c: don't store end_section_nr in memory blocks".
    Without the patch, the command option fails with the error message "kmem:
    invalid structure member offset: memory_block_end_section_nr".

  * Fix for Linux 4.19.5 and later 4.19-based x86_64 kernels which are NOT
    configured with CONFIG_RANDOMIZE_BASE and have backported kernel commit
    d52888aa2753e3063a9d3a0c9f72f94aa9809c15, titled "x86/mm: Move LDT remap
    out of KASLR region on 5-level paging", which modified the 4-level and
    5-level paging PAGE_OFFSET values.  Without this patch, the crash session
    fails during initialization with the error message "crash: seek error:
    kernel virtual address: <address> type: "tss_struct ist array".

  * Additional fix for the "kmem -n" option on Linux-5.4-rc1 and later kernels
    that contain commit b6c88d3b9d38f9448e0fcf44847a075ea81d5ca2, titled
    "drivers/base/memory.c: don't store end_section_nr in memory blocks".  The
    initial fix only addressed the x86_64 architecture; this incremental patch
    addresses the other architectures.

  * In the unlikely event that the panic task in a dumpfile cannot be
    determined by the normal means, scan the kernel log buffer for panic
    keywords, and if found, generate the panic task from the CPU number that
    is specified following the panic message.

  * Adjust a crash-7.1.8 patch for support of /proc/kcore as the live memory
    source in Linux 4.8 and later x86_64 kernels configured with
    CONFIG_RANDOMIZE_BASE, which randomizes the unity-mapping PAGE_OFFSET
    value.  Since the problem only arises before the determination of the
    randomized PAGE_OFFSET value, restrict the patch such that it only takes
    effect during session initialization.

  * Add support for extended numbering support in ELF dumpfiles to handle more
    than PN_XNUM (0xffff) program headers.  If the real number of program
    header table entries is equal to or greater than PN_XNUM, the e_phnum
    field of the ELF header is set to PN_XNUM, and the actual number is set in
    the sh_info field of the section header at index 0.

  * Fix for a "warning: large integer implicitly truncated to unsigned type
    [-Woverflow]" compiler message generated on 32-bit architectures as a
    result of the "Additional fix for the kmem -n option" patch above.

  * Add support for handling openSUSE vmlinux files which will be shipped in
    .xz compressed format.  Without the patch, only gzip and bzip2 formats are
    supported.

  * Fix for the determination of the ARM64 page size on Linux 4.4 and earlier
    kernels that do not have vmcoreinfo data.  Without the patch, the crash
    session fails during initialization with the error message "crash: "cannot
    determine page size".

  * Determine the ARM64 kernel's "vabits_actual" value by reading the new
    TCR_EL1.T1SZ vmcoreinfo entry.

  * Fix to determine the ARM64 kernel's "vabits_actual" value from the ELF
    header of a dumpfile created with the "snap.so" extension module.

  * Fix two typos in the examples section of the "help bt" display, which
    mistakenly show "bf -f" and "bf -FF" instead of "bt -f" and "bt -FF".

  * Similar to ARM64, the X86_64, PPC64 and S390x architectures will use the
    exported value of MAX_PHYSMEM_BITS from the vmcoreinfo data as the
    preferred method if it is available.

  * If an S390X kernel crashes before vmcoreinfo initialization, there is no
    way to extract the KASLR offset for such early dumps.  In a new S390X
    kernel patch, the KASLR offset will be stored in the lowcore memory during
    early boot and then overwritten after vmcoreinfo is initialized.  This
    patch allows crash to identify the KASLR offset that is stored in the
    lowcore memory.



=== debian/control ===
--- 
+++ 
@@ -1,10 +1,11 @@
 Source: crash
 Section: utils
 Priority: optional
-Maintainer: Troy Heber <troyh@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Troy Heber <troyh@debian.org>
 Uploaders:
 Build-Depends: debhelper (>= 10), dpkg-dev (>= 1.16.1), quilt (>= 0.47), binutils, binutils-dev, bison, gawk, flex, zlib1g-dev, libncurses5-dev, liblzo2-dev, libsnappy-dev
-Standards-Version: 4.3.0.0
+Standards-Version: 4.5.0.0
 XS-Testsuite: autopkgtest
 
 Package: crash

## crash 7.2.8-1+cl4u1

=== Makefile ===
--- 
+++ 
@@ -269,11 +269,9 @@
 	if [ "${ARCH}" = "x86_64" ] && [ "${TARGET}" = "PPC64" ] && [ -f ${GDB}-ppc64le-support.patch ]; then \
 		patch -d ${GDB} -p1 -F0 < ${GDB}-ppc64le-support.patch ; \
 	fi
-	if [ -f /usr/include/proc_service.h ]; then \
-		grep 'extern ps_err_e ps_get_thread_area (struct' /usr/include/proc_service.h; \
-		if [ $$? -eq 0 ]; then \
-			patch -p0 < ${GDB}-proc_service.h.patch; \
-		fi; \
+	if echo '#include <proc_service.h>' | ${CC} -E - | \
+			grep -q 'extern ps_err_e ps_get_thread_area (struct'; then \
+		patch -p0 < ${GDB}-proc_service.h.patch; \
 	fi
 
 library: make_build_data ${OBJECT_FILES}
@@ -294,3 +292,4 @@
 	@./configure ${CONF_TARGET_FLAG} -q -b
 	@make --no-print-directory do_clean
 
+do_clean:

=== debian/changelog ===
crash (7.2.8-1+cl4u1) CumulusLinux-4; urgency=medium

  [ Benjamin Poirier ]
  * CUMULUS: Apply debian/patches/0001-dont-git-clone-eppic-extension.patch
  * CUMULUS: Apply debian/patches/0002-multiarch-libc.patch
  * CUMULUS: debian: Change source package format to "3.0 (git)"
  * CUMULUS: Search for kernel version in uts version string
  * CUMULUS: debian: Add changelog entry for 7.2.8-1+cl4u1
  * CUMULUS: Force host arch for gdb build

  [ Timothy Lee ]
  * Prevent extensions, lzo, and snappy from being made in parallel.

 -- Cumulus Networks <dev-support@cumulusnetworks.com>  Wed, 03 Jun 2020 09:37:20 +0900

=== debian/control ===
--- 
+++ 
@@ -1,10 +1,9 @@
 Source: crash
 Section: utils
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Troy Heber <troyh@debian.org>
+Maintainer: Troy Heber <troyh@debian.org>
 Uploaders:
-Build-Depends: debhelper (>= 10), dpkg-dev (>= 1.16.1), quilt (>= 0.47), binutils, binutils-dev, bison, gawk, flex, zlib1g-dev, libncurses5-dev, liblzo2-dev, libsnappy-dev
+Build-Depends: debhelper (>= 10), dpkg-dev (>= 1.16.1), binutils, binutils-dev, bison, gawk, flex, zlib1g-dev, libncurses5-dev, liblzo2-dev, libsnappy-dev
 Standards-Version: 4.5.0.0
 XS-Testsuite: autopkgtest

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
export DEB_BUILD_HARDENING=1
export DEB_BUILD_MAINT_OPTIONS=hardening=+all
export EXTDIR=/usr/lib/crash/extensions
DPKG_EXPORT_BUILDFLAGS=1
include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/buildflags.mk

%:
	dh $@

override_dh_auto_build:
	dh_auto_build -- all extensions lzo snappy \
		GDB_CONF_FLAGS="--build=$(DEB_BUILD_GNU_TYPE)"

override_dh_auto_clean:
	cp $(CURDIR)/Makefile $(CURDIR)/debian/Makefile.ori
	dh_auto_clean

override_dh_clean:
	dh_clean
	cp $(CURDIR)/debian/Makefile.ori $(CURDIR)/Makefile
	rm -Rf $(CURDIR)/configure
	rm -Rf $(CURDIR)/gdb-7.6
	rm -Rf $(CURDIR)/gdb.files
	rm -Rf $(CURDIR)/build_data.c
	rm -Rf $(CURDIR)/extensions/*.so
	rm -Rf $(CURDIR)/CFLAGS.extra
	rm -Rf $(CURDIR)/LDFLAGS.extra
	rm -Rf $(CURDIR)/extensions/defs.h

override_dh_auto_install:
	dh_auto_install
	cp $(CURDIR)/debian/Makefile.ori $(CURDIR)/Makefile
	mkdir -p $(CURDIR)/debian/crash$(EXTDIR)
	cp -p extensions/*.so $(CURDIR)/debian/crash$(EXTDIR)

override_dh_auto_test:
	# Crash does not provide a testsuite
